CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


  GPS_PIN_TX       = 0
  GPS_PIN_RX       = 1 
  GPS_PIN_RST      = 2  
  
  GSM_Rx = 3
  GSM_Tx = 4
  GSM_power = 5
  GSM_Baud = 9600

  
  Pol_Rx = 6                    
  Pol_Baud = 9600              

  CLS = 16
  CR = 13
  QUOTE = 34  

VAR

  byte AT_Reponse[150], dataSet[150]
  byte char, ptr, ptr1, ptr2
  Long stack3[1000], stack4[1000], stack6[1000], cog2, cog3, cog4, cog6
  Long UTC_Time, Local_Time, Heure_Local, Minutes_Local, Seconde_Local, jour, mois, annee, Altitude, Degre_latitude, Minute_latitude, Seconde_latitude
  Long Degre_longitude, Minute_longitude, Seconde_longitude, Vitesse, Nbres_satellites
  Long a, b,a0,c, d,c0,NU1,NU2,NU3, Checksum   
  byte DP1, DP2, LP1, LP2                                                            

OBJ

  pst : "Parallax Serial Terminal"
  GSM : "FullDuplexSerial"
  GPS  : "gps_basic"
  Pol : "FullDuplexSerial" 

Pub main | lat, lon, ok

  cog2 := pst.start(115200)
  pst.str(String(pst#NL,"Le cog2 est: ",9))
  pst.dec(Cog2)

  cog3 := Pol.start(Pol_Rx, -1, 0, Pol_Baud)   
  pst.str(String(pst#NL,"Le cog3 est: ",9))
  pst.dec(Cog3)

  cog4 := GPS.startx(GPS_PIN_RX, 2, 9600, 2500)
  pst.str(String(pst#NL,"Le cog4 est: ",9))
  pst.dec(Cog4)

  cog6 := GSM.start(GSM_Rx, GSM_Tx, 0, GSM_Baud)
  pst.str(String(pst#NL,"Le cog6 est: ",9)) 
  pst.dec(Cog6)

  
  COGINIT(cog3,Poso_Start,@stack3)
  COGINIT(cog4,GPS_Start,@stack4)
  COGINIT(cog6,GSM_Start,@stack6)

      
  
PUB GSM_Start

  Start_Module
  waitcnt(clkfreq*5+cnt)

  ptr := 0

  gsm.str(string("AT",13))  
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 0: ",9))
  pst.Str(@AT_Reponse)
  pst.Str(String(13)) 
  
  gsm.str(string("AT+CPIN=",34,"00000000",34,13))  
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 0,4: ",9))
  pst.Str(@AT_Reponse)
  pst.Str(String(13)) 

  gsm.str(string("AT+CGDCONT=1,",34,"IP",34,",",34,"orange",34,13))  
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 2: ",9))
  pst.Str(@AT_Reponse)
  pst.Str(String(13)) 

  waitcnt(clkfreq*30+cnt)

  gsm.str(string("AT+CGATT=1",13))  
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 1: ",9))
  pst.Str(@AT_Reponse)
  pst.Str(String(13))  
  
  gsm.str(String("AT+SAPBR=3,1,",34,"Contype",34,",",34,"GPRS",34,13))
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 3: ",9))
  pst.Str(@AT_Reponse)           
  pst.Str(String(13))   
   
  gsm.str(String("AT+SAPBR=3,1,",34,"APN",34,",",34,"orange.fr",34,13))
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 4: ",9))
  pst.Str(@AT_Reponse)           
  pst.Str(String(13))   
  
  gsm.str(String("AT+SAPBR=3,1,",34,"USER",34,",",34,"orange",34,13))
  Rx
                               
  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 5: ",9))
  pst.Str(@AT_Reponse)           
  pst.Str(String(13)) 
  
  gsm.str(String("AT+SAPBR=3,1,",34,"PWD",34,",",34,"orange",34,13))
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 6: ",9))
  pst.Str(@AT_Reponse)           
  pst.Str(String(13))     

  gsm.str(String("AT+SAPBR=1,1",13))            
  Rx

  pst.Str(String(13))  
  pst.str(String("La rponse  ta requete est la suivante 7: ",9))
  pst.Str(@AT_Reponse)           
  pst.Str(String(13))   

PUB Start_Module

  dira[GSM_power]~~
  outa[GSM_power]~
  waitcnt(clkfreq/5+cnt)
  outa[GSM_power]~~
  
PUB Rx

  Rx_GSM



Pub Rx_GSM  

    GSM.RxFlush
    repeat
      char := GSM.Rx
      pst.dec(char) 
    while (char <> 10) 
    RxPacketNow_GSM

Pri RxPacketNow_GSM | valeur

    ptr := 0
    ptr1 := 0
    
    Repeat   
      char := GSM.Rx
      pst.dec(char) 
      AT_Reponse[ptr++] := Char
    while Char <> 13
    
    AT_Reponse[--ptr] := 0

PUB GPS_Start | ok   

repeat
  
  if (gps.hasgps == false)                                
      pst.str(string("No GPS"))
  else
    pst.str(String(CR,"OK"))
    pst.dec(gps.s_gpsfix)                                    ' gps quality (fix)
    ok := gps.n_gpsfix                                        ' flag for other fields
    pst.str(String(CR,"Nbre satellite est: "))
    Nbres_satellites := GPS.n_satellites
    pst.dec(Nbres_satellites)
    pst.str(String(CR,"UTC Time: ")) 
    UTC_Time := GPS.fs_utc_time
    pst.str(UTC_Time)
    pst.str(String(CR,"Local Time: "))
    Local_Time := GPS.fs_local_time
    pst.str(Local_Time)
    pst.str(String(CR,"Local Time: ")) 
    Heure_Local := GPS.s_local_hrs
    Heure_Local := StrToDec(Heure_Local)
    pst.dec(Heure_Local)
    Minutes_Local := GPS.s_mins
    Minutes_Local := StrToDec(Minutes_Local)
    pst.dec(Minutes_Local)
    Seconde_Local := GPS.s_secs
    Seconde_Local := StrToDec(Seconde_Local)
    pst.dec(Seconde_Local)
    pst.str(String(CR,"Date: ")) 
    pst.str(GPS.fs_date)
    pst.str(String(CR,"Date: ")) 
    jour := GPS.s_day
    jour := StrToDec(jour)
    pst.dec(jour)
    mois := GPS.s_month
    mois := StrToDec(mois)
    pst.dec(mois)
    annee := GPS.s_year
    annee := StrToDec(annee)
    pst.dec(annee)
    pst.str(String(CR,"La latitude est: "))
    Degre_latitude := GPS.n_latd
    pst.dec(Degre_latitude)
    pst.str(String(""))
    Minute_latitude := GPS.n_latm
    pst.dec(Minute_latitude)
    pst.str(String("'"))
    Seconde_latitude := GPS.n_lats
    pst.dec(Seconde_latitude)
    pst.str(String(QUOTE)) 
    pst.str(String(CR,"La longitude est: "))
    Degre_longitude := GPS.n_lond
    pst.dec(Degre_longitude)
    pst.str(String(""))
    Minute_longitude := GPS.n_lonm
    pst.dec(Minute_longitude)
    pst.str(String("'"))
    Seconde_longitude := GPS.n_lons
    pst.dec(Seconde_longitude)
    pst.str(String(QUOTE))
    pst.str(String(CR,"L'altitude est: "))
    Altitude := GPS.n_altm
    pst.dec(Altitude)
    pst.str(String(CR,"La vitesse est de: ")) 
    Vitesse := GPS.n_speedm*1.609344
    pst.dec(Vitesse)
    pst.str(String(" Km/h "))
    waitcnt(clkfreq + cnt)
    pst.Str(String(CLS))

PUB StrToDec(stringptr) : value | index, multiply

    '' Converts a zero terminated string representation of a decimal number to a value

    value := index := 0
    repeat until ((char := byte[stringptr][index++]) == 0)
       if char => "0" and char =< "9"
          value := value * 10 + (char - "0")
    if byte[stringptr] == "-"
       value := - value

PUB Poso_Start

  DP1 := $42
  DP2 := $4d
  LP1 := $00
  LP2 := $14
repeat
  Poso_Rx

  pst.str(string(pst#NL,"a = "))
  pst.Dec(a)
  pst.str(string(pst#NL,"b = "))
  pst.Dec(b)
  pst.str(string(pst#NL,"a0 = ")) 
  pst.Dec(a0)
  pst.str(string(pst#NL,"c = "))
  pst.Dec(c)
  pst.str(string(pst#NL,"d = "))
  pst.Dec(d)
  pst.str(string(pst#NL,"c0 = "))
  pst.Dec(c0)
  pst.str(string(pst#NL))
  pst.dec(NU1)
  pst.str(string(pst#NL))
  pst.dec(NU2)
  pst.str(string(pst#NL))
  pst.dec(NU3)
  pst.str(string(pst#NL,"Check Sum:"))
  pst.hex(checksum,4)



Pub Poso_Rx| DP_char1, DP_char2, LP_char1, LP_char2
{{
  Wait for incoming packet until packet identifer found ($7E)
  Then process packet.
  XB.API_RX
  Once data is received, the type of packet can be checked for processing:
  IF XB.RxData == $ 83 ' message string
      ...
  See RxPacket Now for more information
}}

'    pst.str(string(pst#NL, "Debut reception:", pst#NL))

   ' pst.Hex(_SrcAddr16,2) 
    repeat
      DP_char1 := Pol.Rx
'      pst.hex(DP_char1,2)
'      pst.Str(String(pst#NL,"ok DP_char1", pst#NL)) 
      if ( DP_char1 == DP1)
        DP_char2 := Pol.Rx
'        pst.hex(DP_char2,2)
'        pst.Str(String(pst#NL,"good DP_char2", pst#NL)) 
        if (DP_char2 == DP2)
          LP_char1 := Pol.Rx
 '         pst.hex(LP_char1,2)
'          pst.Str(String(pst#NL,"parfait LP_char1", pst#NL))
          if (LP_char1 == LP1)
             LP_char2 := Pol.Rx
'             pst.hex(LP_char2,2)
'             pst.Str(String(pst#NL,"genial LP_char2", pst#NL))    
    while (LP_char2 <> LP2)  
'        pst.Str(String(pst#NL))
'        pst.str(char)
'    pst.str(string(pst#NL, "Debut Analyze paquet reu:", pst#NL))
    RxPacketNow                             ' Analyze received packet

         
PUB RxTime(ms)
{{
        See FullDuplex Serial Documentation
        '' x:= Serial.RxTime(100)' receive byte with 100mS timeout
        '' FOR Transparent (Non-API) MODE USE
}}
        return (Pol.RxTime(ms))

Pri RxPacketNow | chan, prt2
{{
  Process incoming frame based on Identifier
  See individual cases for data returned.
  Check ident with :
  IF XB.rxIdent == value
    and process data accordingly as shown below
    
}}
'    pst.str(string("Recup caractere transmis : "))
    ptr := 0
    Repeat 20
'      pst.str(string("Recup caractere transmis : "))
      
      Char := RxTime(1)            ' accept remainder of data
'      pst.hex(Char,2)
'      pst.str(string (pst#NL))
      dataSet[ptr++] := Char 

    ptr := 0

    a := dataSet[ptr++] << 8 + dataSet[ptr++]
    b := dataSet[ptr++] << 8 + dataSet[ptr++]
    a0 := dataSet[ptr++] << 8 + dataSet[ptr++]
    c := dataSet[ptr++] << 8 + dataSet[ptr++]
    d := dataSet[ptr++] << 8 + dataSet[ptr++]
    c0 := dataSet[ptr++] << 8 + dataSet[ptr++]
    NU1 := dataSet[ptr++] << 8 + dataSet[ptr++]
    NU2 := dataSet[ptr++] << 8 + dataSet[ptr++]
    NU3 := dataSet[ptr++] << 8 + dataSet[ptr++]
    Checksum := dataSet[ptr++] << 8 + dataSet[ptr++] 